import { world, system, ItemStack } from '@minecraft/server';

const blockList = [
	'raigen:daganite_wall',
	'raigen:cobbled_daganite_wall',
	'raigen:daganite_bricks_wall',
	'raigen:polished_daganite_wall',
	'raigen:polished_daganite_bricks_wall',
];

world.afterEvents.playerInteractWithBlock.subscribe(e =>{
	let block = e.block;
	let blockFace = e.blockFace;
	let item = e.itemStack;
	if(item == undefined) return;
	system.run(() =>{
		check(block, item, blockFace);
	});
});
function check(block, item, blockFace){
	if(!blockList.includes(item.typeId)) return;
	switch(blockFace.toLowerCase()){
		case 'up':
			detect(block.above(), item);
			break;
		case 'down':
			detect(block.below(), item);
			break;
		case 'north':
			detect(block.north(), item);
			break;
		case 'east':
			detect(block.east(), item);
			break;
		case 'south':
			detect(block.south(), item);
			break;
		case 'west':
			detect(block.west(), item);
			break;
		default:
			break;
	}
}
world.afterEvents.blockExplode.subscribe(e =>{
	let block = e.block;
	system.run(() =>{
		detect(block, undefined);
	});
});
world.beforeEvents.playerBreakBlock.subscribe(e =>{
	let block = e.block;
	system.run(() =>{
		detect(block.above(), undefined);
		detect(block.below(), undefined);
		detect(block.north(), undefined);
		detect(block.east(), undefined);
		detect(block.south(), undefined);
		detect(block.west(), undefined);
	});
});
world.afterEvents.pistonActivate.subscribe(e =>{
	let blocks;
	try{ blocks = e.piston.getAttachedBlocks(); }
	catch{ blocks = undefined; }
	if(blocks == undefined || blocks.length == 0) return;
	system.run(() =>{
		blocks.forEach(b =>{
			detect(b.above(), undefined);
			detect(b.below(), undefined);
			detect(b.north(), undefined);
			detect(b.east(), undefined);
			detect(b.south(), undefined);
			detect(b.west(), undefined);
		});
	});
});

function detect(b, i){
	if(!blockList.includes(b.typeId)) return;
	for(var x = -1; x <= 1; x++){
		for(var y = -1; y <= 1; y++){
			for(var z = -1; z <= 1; z++){
				b.dimension.runCommand(`fill ${b.x + x} ${b.y + y} ${b.z + z} ${b.x + x} ${b.y + y} ${b.z + z} ${i == undefined ? b.typeId : i.typeId} ["raigen:index"=5, "raigen:status"=15] replace ${i == undefined ? b.typeId : i.typeId} []`);
			}
		}
	}
}