import { world, system, ItemStack, Vector } from '@minecraft/server';

system.afterEvents.scriptEventReceive.subscribe(e => {
  let entity = e.sourceEntity;
	if(entity.typeId == 'minecraft:item') return;
	if(e.id == 'raigen:jawly_rubber_bounce'){
		entity.applyKnockback(0, 0, 0, 1.25);
	}
	//mob damages
	if(e.id == 'raigen:dagan_damage'){
		var view = entity.getViewDirection();
		let { x, z } = (new Vector(view.x, 0 ,view.z)).normalized();
		var offset, location;
		offset = 3;
		location = Vector.add(entity.location, Vector.multiply({ x, y: 0, z }, offset));
		entity.runCommand(`summon raigen:dagan ${location.x.toFixed(2)} ${entity.location.y} ${location.z.toFixed(2)} ~ ~ raigen:event_damage`);
		offset = 6;
		location = Vector.add(entity.location, Vector.multiply({ x, y: 0, z }, offset));
		entity.runCommand(`summon raigen:dagan ${location.x.toFixed(2)} ${entity.location.y} ${location.z.toFixed(2)} ~ ~ raigen:event_damage`);
	}
	if(e.id == 'raigen:dagan_loot'){
		var col = [ 'raigen:axe_index', 'raigen:sword_index', 'raigen:pickaxe_index' ];
		var mat = [ 'none', 'wooden', 'stone', 'iron', 'gold', 'diamond', 'netherite' ];
		col.forEach(c =>{
			let index = entity.getProperty(c);
			if(mat[index] == 'none') return;
			entity.runCommand(`loot spawn ${entity.location.x} ${entity.location.y} ${entity.location.z} loot "absolute_carnage/entities/dagan/${mat[index]}_${c.replace('raigen:', '').replace('_index', '')}"`);
		});
	}
	if(e.id == 'raigen:mortemeer_death'){
		let c = 5 + Math.floor(Math.random() * 15);
		for(let i = 0; i < c; i++){
			let rx = Math.random().toFixed(2);
			let ry = Math.random().toFixed(2);
			let rz = Math.random().toFixed(2);
			entity.runCommand(`summon raigen:maggot ~${rx} ~${ry} ~${rz} ~~ raigen:event_from_mortemeer`);
		}
	}
	if(e.id == 'raigen:maggot_jump'){
		entity.applyKnockback(0, 0, 0, (0.5 + Math.random() * 0.35).toFixed(2) * 1);
	}
	if(e.id == 'raigen:rhyther_swing_damage'){
		var view = entity.getViewDirection();
		let { x, z } = (new Vector(view.x, 0 ,view.z)).normalized();
		var offset, location;
		offset = 1.5;
		location = Vector.add(entity.location, Vector.multiply({ x, y: 0, z }, offset));
		entity.runCommand(`summon raigen:rhyther ${location.x.toFixed(2)} ${entity.location.y} ${location.z.toFixed(2)} ~ ~ raigen:event_swing_damage`);
	}
	if(e.id == 'raigen:rhyther_strike_damage'){
		var view = entity.getViewDirection();
		let { x, z } = (new Vector(view.x, 0 ,view.z)).normalized();
		var offset, location;
		offset = 1.5;
		location = Vector.add(entity.location, Vector.multiply({ x, y: 0, z }, offset));
		entity.runCommand(`summon raigen:rhyther ${location.x.toFixed(2)} ${entity.location.y} ${location.z.toFixed(2)} ~ ~ raigen:event_strike_damage`);
		offset = 3;
		location = Vector.add(entity.location, Vector.multiply({ x, y: 0, z }, offset));
		entity.runCommand(`summon raigen:rhyther ${location.x.toFixed(2)} ${entity.location.y} ${location.z.toFixed(2)} ~ ~ raigen:event_strike_damage`);
	}
	if(e.id == 'raigen:rhyther_temp'){
		system.runTimeout(() =>{
			entity.runCommand('event entity @s raigen:event_despawn');
		}, 200 + Math.floor(Math.random() * 100));
	}
	if(e.id == 'raigen:trail_blitz_coord'){
		entity.runCommand(`summon raigen:trail_blitz ~${rnd(-15, 15)} ~${rnd(-2, 2)} ~${rnd(-15, 15)} ~~ raigen:event_coord`);
	}
});

world.afterEvents.entityHitEntity.subscribe(e =>{
	var agg = e.damagingEntity;
	var vic = e.hitEntity;
});
world.afterEvents.entityHurt.subscribe(e =>{
	var dmg = e.damage;
	var src = e.damageSource;
	var vic = e.hurtEntity;
	if(src.cause == 'suicide') return;
	latherinDamage(src, vic);
});

function latherinDamage(s, v){
	if(s.cause != 'contact') return;
	if(s.damagingEntity.typeId != 'raigen:latherin') return;
	v.applyKnockback(rndBet(-1, 1), rndBet(-1, 1), rndBet(rndBet(5, 6) * -1, rndBet(5, 6)), 0);
}

function rnd(l, g){
  if (l > g) { [l, g] = [g, l]; }
  const range = g - l;
  const scaled = Math.random() * range;
  return l + scaled;
}
function rndBet(l, g){
	return Math.random() > 0.5 ? g : l;
}